// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ContentsList.java

package ig.ebook.epub;

import java.io.File;
import java.util.Vector;
import org.apache.commons.io.FileUtils;
import org.apache.commons.io.FilenameUtils;

public class ContentsList
{

    public ContentsList()
    {
        chapterSrc = new Vector();
        chapterTitle = new Vector();
        chapterId = new Vector();
        mediaType = new Vector();
        chapterKind = new Vector();
        putOpf = new Vector();
        putNcx = new Vector();
        tocLevel = new Vector();
        srcPath = new Vector();
        tgtPath = new Vector();
        copyFile = new Vector();
        checkExistCopyfile = new Vector();
        add(0, "tocncx", "Toc", "toc.ncx", true, false, 1, "", "", false, false);
    }

    public int size()
    {
        return chapterSrc.size();
    }

    public void remove(int index)
    {
        chapterSrc.remove(index);
        chapterTitle.remove(index);
        chapterId.remove(index);
        chapterKind.remove(index);
        mediaType.remove(index);
        putOpf.remove(index);
        putNcx.remove(index);
        tocLevel.remove(index);
        srcPath.remove(index);
        tgtPath.remove(index);
        copyFile.remove(index);
        checkExistCopyfile.remove(index);
    }

    public void removeAll()
    {
        chapterSrc.removeAllElements();
        chapterTitle.removeAllElements();
        chapterId.removeAllElements();
        chapterKind.removeAllElements();
        mediaType.removeAllElements();
        putOpf.removeAllElements();
        putNcx.removeAllElements();
        tocLevel.removeAllElements();
        srcPath.removeAllElements();
        tgtPath.removeAllElements();
        copyFile.removeAllElements();
        checkExistCopyfile.removeAllElements();
    }

    public void add(int kind, String id, String title, String src, int toclevel)
    {
        add(kind, id, title, src, true, true, toclevel, "", "", false, false);
    }

    public void add(int kind, String id, String title, String src, boolean putopf, boolean putncx, int toclevel, 
            String srcpath, String tgtpath, boolean copyfile, boolean checkexist)
    {
        chapterKind.add(Integer.valueOf(kind));
        chapterId.add(id);
        chapterTitle.add(title);
        chapterSrc.add(src);
        putOpf.add(Boolean.valueOf(putopf));
        putNcx.add(Boolean.valueOf(putncx));
        tocLevel.add(Integer.valueOf(toclevel));
        srcPath.add(srcpath);
        tgtPath.add(tgtpath);
        copyFile.add(Boolean.valueOf(copyfile));
        checkExistCopyfile.add(Boolean.valueOf(checkexist));
        mediaType.add(getDeaultMediaType(src));
    }

    public int getKind(int index)
    {
        return ((Integer)chapterKind.get(index)).intValue();
    }

    public String getId(int index)
    {
        return (String)chapterId.get(index);
    }

    public String getTitle(int index)
    {
        return (String)chapterTitle.get(index);
    }

    public String getSrc(int index)
    {
        return (String)chapterSrc.get(index);
    }

    public boolean isPutOpf(int index)
    {
        return ((Boolean)putOpf.get(index)).booleanValue();
    }

    public boolean isPutToc(int index)
    {
        return ((Boolean)putNcx.get(index)).booleanValue();
    }

    public int getTocLevel(int index)
    {
        return ((Integer)tocLevel.get(index)).intValue();
    }

    public String getSrcPath(int index)
    {
        return (String)srcPath.get(index);
    }

    public String getTgtPath(int index)
    {
        return (String)tgtPath.get(index);
    }

    public String getMediaType(int index)
    {
        return (String)mediaType.get(index);
    }

    public boolean isCopyFile(int index)
    {
        return ((Boolean)copyFile.get(index)).booleanValue();
    }

    public boolean isCheckExistCopyfile(int index)
    {
        return ((Boolean)checkExistCopyfile.get(index)).booleanValue();
    }

    public int getMaxTocLevel()
    {
        return maxTocLevel;
    }

    public void setMaxTocLevel(int maxTocLevel)
    {
        this.maxTocLevel = maxTocLevel;
    }

    public String getWorkDir()
    {
        return workDir;
    }

    public void setWorkDir(String workDir)
    {
        this.workDir = workDir;
    }

    public void copyContentsFile()
        throws Exception
    {
        for(int i = 0; i < chapterKind.size(); i++)
        {
            if(!((Boolean)copyFile.get(i)).booleanValue())
                continue;
            File fromFile = new File((String)srcPath.get(i));
            if(((Boolean)checkExistCopyfile.get(i)).booleanValue() && !fromFile.exists())
                throw new Exception((new StringBuilder()).append(fromFile.getPath()).append(" font not found!").toString());
            try
            {
                File toFile = new File((new StringBuilder()).append(getWorkDir()).append((String)tgtPath.get(i)).toString());
                FileUtils.copyFile(fromFile, toFile);
            }
            catch(Exception e)
            {
                throw new Exception((new StringBuilder()).append(fromFile.getPath()).append(" file copy error : ").append(e.getMessage()).toString());
            }
        }

    }

    private String getDeaultMediaType(String file)
    {
        String mediatype = "";
        String ext = FilenameUtils.getExtension(file).toLowerCase();
        if(ext.equals("jpg"))
            mediatype = "image/jpeg";
        else
        if(ext.equals("png"))
            mediatype = "image/png";
        else
        if(ext.equals("gif"))
            mediatype = "image/gif";
        else
        if(ext.equals("xhtml") || ext.equals(ext))
            mediatype = "application/xhtml+xml";
        else
        if(ext.equals("css"))
            mediatype = "text/css";
        else
        if(ext.equals("ncx"))
            mediatype = "application/x-dtbncx+xml";
        return mediatype;
    }

    public int searchSrcPath(String srcPath)
    {
        int index = -1;
        int i = 0;
        do
        {
            if(i >= size())
                break;
            if(getSrcPath(i).equalsIgnoreCase(srcPath))
            {
                index = i;
                break;
            }
            i++;
        } while(true);
        return index;
    }

    public static final int TOC_FILE = 0;
    public static final int TITLE_FILE = 1;
    public static final int CHAPTER_FILE = 2;
    public static final int IMAGE_FILE = 3;
    public static final int CSS_FILE = 4;
    public static final int FONT_FILE = 5;
    private Vector chapterSrc;
    private Vector chapterTitle;
    private Vector chapterId;
    private Vector chapterKind;
    private Vector putOpf;
    private Vector putNcx;
    private Vector tocLevel;
    private Vector srcPath;
    private Vector tgtPath;
    private Vector copyFile;
    private Vector checkExistCopyfile;
    private Vector mediaType;
    private int maxTocLevel;
    private String workDir;
}
