// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   EpubWriter.java

package ig.ebook.epub;

import java.io.File;
import java.util.UUID;
import kte.KteProperty;
import org.apache.commons.io.*;

// Referenced classes of package ig.ebook.epub:
//            ContentsList, Mimetype, Container, Css, 
//            TitlePage, Paragraph, ChapterPage, Opf, 
//            Ncx, Zip

public class EpubWriter
{

    public EpubWriter()
    {
        iChapterNo = 1;
        workDir = "";
        cl = null;
        props = null;
        chapter = null;
        iStep = 0;
        workDir = (new StringBuilder()).append(System.getProperty("java.io.tmpdir")).append("_kte_").append(UUID.randomUUID().toString()).append("/").toString();
        cl = new ContentsList();
        cl.setWorkDir(workDir);
        iStep = 0;
    }

    public void setKteProperty(KteProperty props)
    {
        this.props = props;
        if(props.isEmptyProperty("work.directory"))
            props.setProperty("work.directory", workDir);
    }

    public int write(boolean stepProcess)
        throws Exception
    {
        if(!stepProcess)
            iStep = 11;
        if(iStep == 0 || iStep == 11)
            createTempDir();
        if(iStep == 1 || iStep == 11)
            write_mimetype();
        if(iStep == 2 || iStep == 11)
            write_container();
        if(iStep == 3 || iStep == 11)
            write_title_page();
        if(iStep == 4 || iStep == 11)
            write_chapter_page();
        if(iStep == 5 || iStep == 11)
            write_stylesheet();
        if(iStep == 6 || iStep == 11)
            write_content_opf();
        if(iStep == 7 || iStep == 11)
            write_toc_ncx();
        if(iStep == 8 || iStep == 11)
            cl.copyContentsFile();
        if(iStep == 9 || iStep == 11)
        {
            File file = new File(props.getProperty("text.file"));
            String epub = (new StringBuilder()).append(file.getParent()).append("/").append(FilenameUtils.getBaseName(file.getName())).append(".epub").toString();
            Zip.zip(workDir, epub);
        }
        if(iStep == 10 || iStep == 11)
        {
            deleteTempDir();
            iStep = 11;
        }
        iStep++;
        return iStep;
    }

    protected void createTempDir()
        throws Exception
    {
        try
        {
            FileUtils.forceMkdir(new File((new StringBuilder()).append(workDir).append("META-INF").toString()));
            FileUtils.forceMkdir(new File((new StringBuilder()).append(workDir).append("OEBPS/images").toString()));
        }
        catch(Exception e)
        {
            throw new Exception((new StringBuilder()).append("create temp directory : ").append(e.getMessage()).toString());
        }
    }

    protected void deleteTempDir()
        throws Exception
    {
        try
        {
            FileUtils.forceDelete(new File(workDir));
        }
        catch(Exception e)
        {
            throw new Exception((new StringBuilder()).append("delete temp directory : ").append(e.getMessage()).toString());
        }
    }

    protected void write_mimetype()
        throws Exception
    {
        (new Mimetype()).write(workDir);
    }

    protected void write_container()
        throws Exception
    {
        (new Container()).write(workDir);
    }

    protected void write_stylesheet()
        throws Exception
    {
        String fontFile = "";
        String tgtPath = "";
        int index = -1;
        String fontNm = "";
        String key = "content_page.css.default.font-face.src.url";
        if(!props.isInsideFont(key) && !props.isEmptyProperty(key) && props.isExistFile(key))
        {
            fontFile = props.getProperty(key);
            tgtPath = (new StringBuilder()).append("OEBPS/uf_default.").append(FilenameUtils.getExtension(fontFile).toLowerCase()).toString();
            cl.add(5, "font", FilenameUtils.getBaseName(fontFile), FilenameUtils.getName(tgtPath), false, false, 1, fontFile, tgtPath, true, true);
        }
        key = "content_page.css.chapter1.font-face.src.url";
        if(!props.isInsideFont(key) && !props.isEmptyProperty(key) && props.isExistFile(key))
        {
            fontFile = props.getProperty(key);
            index = cl.searchSrcPath(fontFile);
            if(index > -1)
                fontNm = cl.getSrc(index);
            else
                fontNm = (new StringBuilder()).append("uf_chapter1.").append(FilenameUtils.getExtension(fontFile).toLowerCase()).toString();
            tgtPath = (new StringBuilder()).append("OEBPS/").append(fontNm).toString();
            cl.add(5, "font", FilenameUtils.getBaseName(fontFile), FilenameUtils.getName(tgtPath), false, false, 1, fontFile, tgtPath, true, true);
        }
        key = "content_page.css.chapter2.font-face.src.url";
        if(!props.isInsideFont(key) && !props.isEmptyProperty(key) && props.isExistFile(key))
        {
            fontFile = props.getProperty(key);
            index = cl.searchSrcPath(fontFile);
            if(index > -1)
                fontNm = cl.getSrc(index);
            else
                fontNm = (new StringBuilder()).append("uf_chapter2.").append(FilenameUtils.getExtension(fontFile).toLowerCase()).toString();
            tgtPath = (new StringBuilder()).append("OEBPS/").append(fontNm).toString();
            cl.add(5, "font", FilenameUtils.getBaseName(fontFile), FilenameUtils.getName(tgtPath), false, false, 1, fontFile, tgtPath, true, true);
        }
        key = "content_page.css.chapter3.font-face.src.url";
        if(!props.isInsideFont(key) && !props.isEmptyProperty(key) && props.isExistFile(key))
        {
            fontFile = props.getProperty(key);
            index = cl.searchSrcPath(fontFile);
            if(index > -1)
                fontNm = cl.getSrc(index);
            else
                fontNm = (new StringBuilder()).append("uf_chapter3.").append(FilenameUtils.getExtension(fontFile).toLowerCase()).toString();
            tgtPath = (new StringBuilder()).append("OEBPS/").append(fontNm).toString();
            cl.add(5, "font", FilenameUtils.getBaseName(fontFile), FilenameUtils.getName(tgtPath), false, false, 1, fontFile, tgtPath, true, true);
        }
        key = "title_page.css.title.font-face.src.url";
        if(!props.isInsideFont(key) && !props.isEmptyProperty(key) && props.isExistFile(key))
        {
            fontFile = props.getProperty(key);
            index = cl.searchSrcPath(fontFile);
            if(index > -1)
                fontNm = cl.getSrc(index);
            else
                fontNm = (new StringBuilder()).append("uf_title.").append(FilenameUtils.getExtension(fontFile).toLowerCase()).toString();
            tgtPath = (new StringBuilder()).append("OEBPS/").append(fontNm).toString();
            cl.add(5, "font", FilenameUtils.getBaseName(fontFile), FilenameUtils.getName(tgtPath), false, false, 1, fontFile, tgtPath, true, true);
        }
        key = "title_page.css.author.font-face.src.url";
        if(!props.isInsideFont(key) && !props.isEmptyProperty(key) && props.isExistFile(key))
        {
            fontFile = props.getProperty(key);
            index = cl.searchSrcPath(fontFile);
            if(index > -1)
                fontNm = cl.getSrc(index);
            else
                fontNm = (new StringBuilder()).append("uf_author.").append(FilenameUtils.getExtension(fontFile).toLowerCase()).toString();
            tgtPath = (new StringBuilder()).append("OEBPS/").append(fontNm).toString();
            cl.add(5, "font", FilenameUtils.getBaseName(fontFile), FilenameUtils.getName(tgtPath), false, false, 1, fontFile, tgtPath, true, true);
        }
        Css css = new Css();
        css.setKteProperty(props);
        css.setContentsList(cl);
        css.write(workDir);
        cl.add(4, "css", css.getFileBaseNm(), css.getFileNm(), true, false, 1, "", "", false, false);
    }

    protected void write_title_page()
        throws Exception
    {
        TitlePage tp = new TitlePage();
        tp.setKteProperty(props);
        tp.write(workDir);
        if(tp.isCreated())
            cl.add(1, tp.getFileBaseNm(), "Title Page", tp.getFileNm(), true, true, 1, "", "", false, false);
        String key = "title-page.info.cover-image.file";
        if(!props.isEmptyProperty(key) && props.isExistFile(key))
        {
            String tgtPath = (new StringBuilder()).append("OEBPS/images/cover.").append(FilenameUtils.getExtension(props.getProperty(key)).toLowerCase()).toString();
            cl.add(3, "image", FilenameUtils.getBaseName(props.getProperty(key)), (new StringBuilder()).append("images/").append(FilenameUtils.getName(tgtPath)).toString(), true, false, 1, props.getProperty(key), tgtPath, true, false);
        }
    }

    protected void write_chapter_page()
        throws Exception
    {
        boolean isCreateNewChapter = true;
        boolean isPutToc = false;
        int tocLevel = 1;
        boolean isGetChapterTitle = false;
        boolean isGetChapterTitleNextLine = false;
        double readBytes = 0.0D;
        String strText = "";
        String chapterTitle = "";
        LineIterator it = null;
        Paragraph pg = new Paragraph();
        pg.setProcParagraph(props.isProperty("paragraph_info.process"));
        pg.setParagraphEndChars(props.getProperty("paragraph_info.process.end-chars"));
        pg.setExcludeStartPatten(props.getProperty("paragraph_info.process.exclude-start-patten"));
        pg.setJoinAddSpace(props.isProperty("paragraph_info.process.join-add-space"));
        boolean isKeepBlankLine = props.isProperty("content_page.keep.blank-line");
        boolean isExtractToc = props.isProperty("content_page.extract.toc");
        try
        {
            it = FileUtils.lineIterator(new File(props.getProperty("text.file")), props.getProperty("text.encoding"));
            do
            {
                if(!it.hasNext())
                    break;
                String strReadLine = it.nextLine();
                strText = strReadLine.trim();
                if(isKeepBlankLine && strText.isEmpty())
                    strText = "*space&";
                if(strText == null || strText.isEmpty())
                    continue;
                if(isPutToc && !isGetChapterTitle)
                {
                    int edPos = strText.length();
                    if(edPos > 100)
                        chapterTitle = (new StringBuilder()).append(strText.substring(0, 100)).append("...").toString();
                    else
                        chapterTitle = strText;
                    isGetChapterTitle = true;
                    isGetChapterTitleNextLine = true;
                }
                if(isExtractToc && (strText.startsWith("*TOC&") || strText.startsWith("**TOC&") || strText.startsWith("***TOC&")))
                {
                    if(strText.startsWith("***TOC&"))
                        tocLevel = 3;
                    else
                    if(strText.startsWith("**TOC&"))
                        tocLevel = 2;
                    else
                        tocLevel = 1;
                    isCreateNewChapter = true;
                    isPutToc = true;
                    int stPos = strText.indexOf('&');
                    int edPos = strText.length();
                    chapterTitle = strText.substring(stPos + 1, edPos).trim();
                    isGetChapterTitle = !chapterTitle.isEmpty();
                    if(!isGetChapterTitle)
                        continue;
                    isGetChapterTitleNextLine = true;
                }
                if(isCreateNewChapter)
                {
                    if(chapter != null && !chapter.isCreated())
                    {
                        pg.setNewParagraph(true);
                        String strTemp = pg.getPrevbufString();
                        if(!strTemp.isEmpty())
                        {
                            _addString(strTemp);
                            readBytes += strTemp.getBytes().length;
                        }
                        pg.setNewParagraph(false);
                        if(chapter.isPutToc() || readBytes > 0.0D)
                        {
                            chapter.write(workDir);
                            cl.add(2, chapter.getFileBaseNm(), chapter.getChapterTitle(), chapter.getFileNm(), true, chapter.isPutToc(), chapter.getTocLevel(), "", "", false, false);
                        }
                    }
                    isCreateNewChapter = false;
                    if(!isExtractToc)
                        tocLevel = 1;
                    chapter = new ChapterPage(iChapterNo, props, chapterTitle, tocLevel);
                    if(isExtractToc)
                    {
                        chapter.setPutToc(isPutToc);
                        isPutToc = false;
                        isGetChapterTitle = false;
                    } else
                    {
                        chapter.setPutToc(true);
                    }
                    readBytes = 0.0D;
                    chapterTitle = "";
                    iChapterNo++;
                    if(isGetChapterTitleNextLine)
                    {
                        isGetChapterTitleNextLine = false;
                        continue;
                    }
                }
                pg.add(strReadLine);
                if(pg.isNewParagraph())
                {
                    String strTemp = pg.getPrevbufString();
                    if(!strTemp.isEmpty())
                    {
                        _addString(strTemp);
                        readBytes += strTemp.getBytes().length;
                        if(readBytes > 20480D)
                            isCreateNewChapter = true;
                    }
                    pg.setNewParagraph(false);
                }
                if(pg.isSpecialChar())
                {
                    pg.setNewParagraph(true);
                    String strTemp = pg.getPrevbufString();
                    if(!strTemp.isEmpty())
                    {
                        _addString(strTemp);
                        readBytes += strTemp.getBytes().length;
                        if(readBytes > 20480D)
                            isCreateNewChapter = true;
                    }
                    pg.setNewParagraph(false);
                    pg.setSpecialChar(false);
                }
            } while(true);
        }
        catch(Exception e)
        {
            throw new Exception((new StringBuilder()).append("chapter file write error : ").append(e.getMessage()).toString());
        }
        finally
        {
            LineIterator.closeQuietly(it);
            if(chapter != null && !chapter.isCreated())
            {
                pg.setNewParagraph(true);
                String strTemp = pg.getPrevbufString();
                if(!strTemp.isEmpty())
                {
                    chapter.add(strTemp);
                    readBytes += strTemp.getBytes().length;
                }
                pg.setNewParagraph(false);
                if(chapter.isPutToc() || readBytes > 0.0D)
                {
                    chapter.write(workDir);
                    cl.add(2, chapter.getFileBaseNm(), chapter.getChapterTitle(), chapter.getFileNm(), true, chapter.isPutToc(), chapter.getTocLevel(), "", "", false, false);
                }
            }
        }
    }

    private void _addString(String str)
    {
        chapter.add(str);
        if(!chapter.getImagePath().isEmpty())
        {
            boolean isFound = false;
            for(int i = 0; i < cl.size(); i++)
                if(chapter.getImagePath().equals(cl.getSrcPath(i)))
                    isFound = true;

            if(!isFound)
                cl.add(3, "image", FilenameUtils.getBaseName(chapter.getImagePath()), (new StringBuilder()).append("images/").append(FilenameUtils.getName(chapter.getTgtImagePath())).toString(), true, false, 1, chapter.getImagePath(), chapter.getTgtImagePath(), true, false);
        }
    }

    protected void write_content_opf()
        throws Exception
    {
        Opf opf = new Opf();
        opf.setKteProperty(props);
        opf.setChaperList(cl);
        opf.write(workDir);
    }

    protected void write_toc_ncx()
        throws Exception
    {
        Ncx ncx = new Ncx();
        ncx.setKteProperty(props);
        ncx.setChaperList(cl);
        ncx.write(workDir);
    }

    protected final String divChars = "*DIV&";
    protected final String tocCharsLevel1 = "*TOC&";
    protected final String tocCharsLevel2 = "**TOC&";
    protected final String tocCharsLevel3 = "***TOC&";
    protected final double chapterMaxSize = 20480D;
    protected final int titleMaxLength = 100;
    private int iChapterNo;
    private String workDir;
    private ContentsList cl;
    private KteProperty props;
    private ChapterPage chapter;
    private int iStep;
}
